﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Shapes;
using System.Windows.Threading;
using Telerik.Windows.Controls;
using Telerik.Windows.Data;
using Telerik.Windows.Media.Imaging;
using System.Windows.Media.Effects;
using Telerik.Windows.Controls.ChartView;

namespace SLApp
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }
    }

    public class DataPointInfoToBurshConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            var fallBackValue = new SolidColorBrush(Colors.Black);

            var series = ((DataPointInfo)value).Series as CategoricalStrokedSeries;

            if (series == null)
                return fallBackValue;

            var path = series.ChildrenOfType<Path>().LastOrDefault();

            if (path != null)
                return path.Fill ?? path.Stroke ?? fallBackValue;
            else
                return fallBackValue;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }


    public class MainViewModel
    {
        public ObservableCollection<PlotInfo> Data1 { get; private set; }

        public ObservableCollection<PlotInfo> Data2 { get; private set; }

        private static readonly Random rnd = new Random(123);

        public MainViewModel()
        {
            this.Data1 = GetTestData(10);
            this.Data2 = GetTestData(10);
        }

        private static ObservableCollection<PlotInfo> GetTestData(int dataSize)
        {
            var result = new ObservableCollection<PlotInfo>();

            result.Add(new PlotInfo { X = new DateTime(2013, 9, 8), Y = rnd.Next(0, 30) });
            result.Add(new PlotInfo { X = new DateTime(2013, 9, 9), Y = rnd.Next(0, 30) });
            result.Add(new PlotInfo { X = new DateTime(2013, 9, 10), Y = 8 });
            result.Add(new PlotInfo { X = new DateTime(2013, 9, 11), Y = 10 });
            result.Add(new PlotInfo { X = new DateTime(2013, 9, 12), Y = rnd.Next(0, 30) });
            result.Add(new PlotInfo { X = new DateTime(2013, 9, 13), Y = rnd.Next(0, 30) });

            return result;
        }
    }

    public class PlotInfo
    {
        public DateTime X { get; set; }

        public double Y { get; set; }
    }
}